## qemu 8.2.1+ds

=== debian/changelog ===
qemu (1:8.2.1+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 06 Feb 2024 08:36:54 +0300

qemu (1:8.2.1+ds-1) unstable; urgency=medium

  * new upstream stable/bugfix release
  * remove all upstream-applied patches
  * d/patches/note-missing-module-pkg-name.diff: fixup
  * replace fix for CVE-2023-6683 (A different fix from upstream)
  * remove the mistakenly-added temp file in d/qemu-block-extra/
  * d/.gitignore: refresh

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 30 Jan 2024 10:32:17 +0300

qemu (1:8.2.0+ds-5) unstable; urgency=medium

  * d/rules, d/run-qemu.mount: use dh_installsystemd to install run-qemu.mount
    (Closes: #1060087)
  * update hppa and seabios-hppa patch series
  * ui-clipboard-avoid-crash-upon-request-when-clipboard-CVE-2023-6683.patch
    (Closes: #1060749, CVE-2023-6683)
  * +target-s390x-Fix-LAE-setting-a-wrong-access-register.patch
  * +tcg-s390x-Fix-encoding-of-VRIc-VRSa-VRSc-insns.patch
    fix chacha20 issue on s390x
  * update hw-vfio-fix-iteration-over-global-VFIODevice-list.patch

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 18 Jan 2024 10:16:31 +0300

=== debian/control ===
# autogenerated file, please edit debian/control-in
Source: qemu
Section: otherosfs
Priority: optional
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper-compat (= 13),
 python3:any,
 meson (>> 0.63.0~), ninja-build,
 flex, bison,
Build-Depends-Arch:
# In comments below we also specify (system-specific) arguments
# to qemu's configure script, -- optional features which depend
# on build-dependencies.
 python3-venv,
# --enable-docs
# for python3-sphinx:native see #995622
 texinfo, python3-sphinx:native, python3-sphinx-rtd-theme,
# always needed
 libglib2.0-dev,
 zlib1g-dev,
# iasl (from acpica-tools) is used only in a single test these days, not for building
# acpica-tools,
# libcapstone is in universe in ubuntu
# --enable-capstone
 libcapstone-dev,
# --enable-linux-aio	linux-any
 libaio-dev            [linux-any],
# libsndio is in universe in ubuntu
# --disable-sndio
# --audio-drv-list=pipewire,pa,alsa,jack,oss,sdl	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
##--audio-drv-list=pa,oss	kfreebsd-any
 libjack-dev  [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libpulse-dev,
 libasound2-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libpipewire-0.3-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# for virtfs (now in libc6)
# --enable-attr
# --enable-bpf	linux-any
 libbpf-dev	[linux-any],
# --enable-brlapi	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libbrlapi-dev         [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-virtfs	linux-any
# needed for virtfs
# --enable-cap-ng	linux-any
 libcap-ng-dev         [linux-any],
# --enable-curl
 libcurl4-gnutls-dev,
# --enable-fdt
 libfdt-dev,
# --enable-fuse
 libfuse3-dev,
# --enable-gnutls
 gnutls-dev,
# --enable-gtk --enable-vte	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libgtk-3-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libvte-2.91-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-libiscsi
 libiscsi-dev,
# --enable-curses	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libncurses-dev        [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-virglrenderer	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libvirglrenderer-dev          [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-opengl	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libepoxy-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libdrm-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libgbm-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-libnfs
 libnfs-dev,
# --enable-numa	i386 amd64 ia64 mips mipsel mips64 mips64el powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc s390x riscv64
 libnuma-dev   [i386 amd64 ia64 mips mipsel mips64 mips64el powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc s390x riscv64],
# --enable-smartcard
 libcacard-dev,
# --enable-pixman
 libpixman-1-dev,
# --enable-rbd		amd64 arm64 mips64el ppc64el ppc64 riscv64 s390x sparc64
 librbd-dev            [amd64 arm64 mips64el ppc64el ppc64 riscv64 s390x sparc64],
# gluster is 64bit-only: #1039604
# --enable-glusterfs	 amd64 arm64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64
 libglusterfs-dev	[amd64 arm64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64],
# --enable-vnc-sasl
 libsasl2-dev,
# --enable-sdl	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libsdl2-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-seccomp	amd64 arm64 armel armhf i386 mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x x32
 libseccomp-dev        [amd64 arm64 armel armhf i386 mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x x32],
# --enable-slirp
 libslirp-dev,
# --enable-spice	 amd64 arm64 armel armhf i386 mips64el mipsel ppc64el x32
 libspice-server-dev	[amd64 arm64 armel armhf i386 mips64el mipsel ppc64el x32],
# --enable-rdma		linux-any
 librdmacm-dev [linux-any], libibverbs-dev [linux-any], libibumad-dev [linux-any],
# --enable-linux-io-uring	linux-any
 liburing-dev                  [linux-any],
# --enable-libusb	linux-any
 libusb-1.0-0-dev      [linux-any],
# --enable-usb-redir	linux-any
 libusbredirparser-dev [linux-any],
# --enable-libssh
 libssh-dev,
# --enable-zstd
 libzstd-dev,
# vde is debian-only since ubuntu/vde2 is in universe
# --enable-vde
 libvdeplug-dev,
 libxen-dev [linux-amd64],
# --enable-nettle
 nettle-dev,
# other optional features we enable
# --enable-libudev
# needed for qga?
 libudev-dev [linux-any],
# --enable-vnc
# --enable-vnc-jpeg
 libjpeg-dev,
# --enable-png
 libpng-dev,
# --enable-libpmem	amd64 arm64
 libpmem-dev           [amd64 arm64],
# --enable-kvm		linux-any
# --enable-vhost-net	linux-any	# is it really linux-specific?
##--enable-lzo todo, for (memory) dumps
##--enable-netmap todo bsd
##--enable-xen-pci-passthrough todo
## auth-pam - for auth for vnc&Co using PAM
#
# the testsuite:
#XXX-cyclic-test-dep-dak-bug seabios [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] <!nocheck>,
# ipxe-qemu [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] <!nocheck>,
# various firmware files (kvmvapic.bin &Co), older qemu-system-data should work
#XXX-cyclic-test-dep-dak-bug qemu-system-data [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] <!nocheck>,
Build-Depends-Indep:
# pc-bios/*.dts => *.dtb (PPC firmware)
 device-tree-compiler,
 gcc-s390x-linux-gnu,
# qemu-palcode/palcode-clipper
 gcc-alpha-linux-gnu,
# u-boot code
 gcc-powerpc-linux-gnu, bc,
# skiboot firmware, openbios
 gcc-powerpc64-linux-gnu,
# skiboot includes <openssl/something.h>
 libssl-dev,
# openbios
 gcc-sparc64-linux-gnu, fcode-utils, xsltproc,
# hppa-firmware
 gcc-hppa-linux-gnu,
# opensbi
 gcc-riscv64-linux-gnu,
# vbootrom/npcm7xx_bootrom
 gcc-arm-none-eabi,
Build-Conflicts: oss4-dev
Standards-Version: 4.6.1
Homepage: http://www.qemu.org/
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/qemu-team/qemu
Vcs-Git: https://salsa.debian.org/qemu-team/qemu.git

Package: qemu-system
Architecture: amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Build-Profiles: <!pkg.qemu.omit-system>
Depends: ${misc:Depends},
 qemu-system-arm,
 qemu-system-mips,
 qemu-system-ppc,
 qemu-system-sparc,
 qemu-system-x86,
 qemu-system-misc
Description: QEMU full system emulation binaries
 QEMU is a fast processor emulator: currently the package supports Alpha, ARM,
 CRIS, i386, LoongArch, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, RISC-V,
 S390x, SH4, SPARC, x86-64, Xtensa and other emulations. By using dynamic
 translation it achieves reasonable speed while being easy to port on new host
 CPUs.
 .
 This metapackage provides the full system emulation binaries for all supported
 targets, by depending on all per-architecture system emulation packages which
 QEMU supports.

Package: qemu-block-extra
Architecture: amd64 arm arm64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 m68k mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sh4 sparc sparc64 x32
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends},
# we need to ensure qemu-block-extra is upgraded with qemu-system-* or qemu-utils
 qemu-system-any (= ${binary:Version}) [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] | qemu-utils (= ${binary:Version}),
Enhances: qemu-utils, qemu-system-misc,
 qemu-system-arm, qemu-system-mips, qemu-system-sparc, qemu-system-x86,
Description: extra block backend modules for qemu-system and qemu-utils
 QEMU is a fast processor emulator: currently the package supports Alpha, ARM,
 CRIS, i386, LoongArch, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, RISC-V,
 S390x, SH4, SPARC, x86-64, Xtensa and other emulations. By using dynamic
 translation it achieves reasonable speed while being easy to port on new host
 CPUs.
 .
 This package provides extra block device backend modules for qemu-system
 emulation and qemu-img from qemu-utils package, which are rarely used and
 has extra dependencies.

Package: qemu-system-data
Architecture: all
Multi-Arch: foreign
Conflicts: sgabios, qemu-skiboot, openbios-sparc, openbios-ppc, qemu-slof,
Replaces:  sgabios, openbios-sparc, openbios-ppc, qemu-slof,
 qemu-system-ppc (<< 1:6.1-4~),
Breaks: qemu-system-ppc (<< 1:6.1-4~),
Provides: qemu-keymaps, sgabios, qemu-skiboot, openbios-sparc, openbios-ppc, qemu-slof,
Depends: ${misc:Depends}
Description: QEMU full system emulation (data files)
 This package provides architecture-neutral data files
 (such as keyboard definitions, icons) for system-mode
 QEMU emulation (qemu-system-*) packages.

Package: qemu-system-common
Architecture: amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: no
Build-Profiles: <!pkg.qemu.omit-system>
Breaks: libvirt-daemon (<< 7.2.0-1)
Depends: ${misc:Depends}, ${shlibs:Depends},
# to fix wrong acl for newly created device node on ubuntu:
Description: QEMU full system emulation binaries (common files)
 QEMU is a fast processor emulator: currently the package supports Alpha, ARM,
 CRIS, i386, LoongArch, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, RISC-V,
 S390x, SH4, SPARC, x86-64, Xtensa and other emulations. By using dynamic
 translation it achieves reasonable speed while being easy to port on new host
 CPUs.
 .
 This package provides common files needed for target-specific
 full system emulation (qemu-system-*) packages.

Package: qemu-system-gui
Architecture: amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
#XXX M-A: same does not really work for now due to /usr/lib/qemu/vhost-user-gpu
#XXX we'll deal with this if some actual need arises,
#XXX by moving that binary back to q-s-common or packaging it separately
#Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
# ui-* depends on ui-opengl
 qemu-system-modules-opengl (= ${binary:Version}),
# we need to ensure qemu-system-gui is upgraded with qemu-system-*
 qemu-system-any (= ${binary:Version}),
# libgl1 is dynamically loaded by sdl display code
 libgl1,

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# stop python from generating .pyc caches
export PYTHONDONTWRITEBYTECODE=1

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
VENDOR := UBUNTU
DEB_BUILD_PARALLEL = yes
else
VENDOR := DEBIAN
endif

# get DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

ifeq ($(and ${DEB_HOST_MULTIARCH},${DEB_HOST_ARCH}),)
# Fast version of dpkg/architecture.mk defining all vars in one go
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

# we build in a sub-subdir so strip that from file paths too
export DEB_CFLAGS_MAINT_APPEND = -ffile-prefix-map=../../=

# Disable LTO on non-amd64 builds, see:
# https://bugs.launchpad.net/ubuntu/+source/qemu/+bug/1921664
# https://issues.redhat.com/browse/RHEL-7385
ifneq ($(DEB_HOST_ARCH),amd64)
  export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

# get CFLAGS LDFLAGS etc (should come after DEB_*MAINT*)
include /usr/share/dpkg/buildflags.mk

# Host architectures we produce packages for.
# when changing this list, check d/control-in too, if any changes
# needs to be done for build deps and --enable options.
system-arch-linux = \
	amd64 arm arm64 armel armhf i386 mips mipsel mips64 mips64el \
	powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
system-arch = ${system-arch-linux}
user-arch = \
	amd64 arm arm64 armel armhf i386 mips mipsel mips64 mips64el \
	ppc64 ppc64el riscv64 s390x sparc sparc64 x32
utils-arch = $(sort ${system-arch} ${user-arch} ia64 hppa m68k sh4 \
	kfreebsd-amd64 kfreebsd-i386)
# subset of system-arch
spice-arch = amd64 i386 arm64 armel armhf mips64el mipsel ppc64el x32

# DEB_BUILD_OPTIONS=parallel=N
MAKEFLAGS += $(subst parallel=,-j,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# verbose build
V = $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)

NINJA = ninja $(if $V,-v) $(or $(filter -j%,${MAKEFLAGS}),-j1)

# list of packages we're supposed to build
BUILD_PACKAGES := $(shell dh_listpackages)

enable-system = $(if $(filter qemu-system,${BUILD_PACKAGES}),y)
enable-user = $(if $(filter qemu-user,${BUILD_PACKAGES}),y)
enable-user-static = $(if $(filter qemu-user-static,${BUILD_PACKAGES}),y)

QEMU_XEN = /usr/libexec/xen-qemu-system-i386
PKGVERSION = Debian ${DEB_VERSION}
SAVEMODDIR = /run/qemu/$(shell echo -n "${PKGVERSION}" | tr --complement '[:alnum:]+-.~' '_')
sysdataidir = debian/qemu-system-data/usr/share/qemu
libdir = /usr/lib/${DEB_HOST_MULTIARCH}
FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios:/usr/lib/ipxe/qemu

ALPHAEV67_CROSSPFX = alpha-linux-gnu-
PPC_CROSSPFX = powerpc-linux-gnu-
PPC64_CROSSPFX = powerpc64-linux-gnu-
RISCV64_CROSSPFX = riscv64-linux-gnu-
ARM_CROSSPFX = arm-none-eabi-

extra-cflags = ${CFLAGS} ${CPPFLAGS}
extra-ldflags = ${LDFLAGS} -Wl,--as-needed
# we add another set of configure options from debian/control
common_configure_opts = \
	--with-pkgversion="$(PKGVERSION)" \
	--extra-cflags="${extra-cflags}" \
	--extra-ldflags="${extra-ldflags}" \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libdir=${libdir} \
	--libexecdir=/usr/lib/qemu \
	--firmwarepath=${FIRMWAREPATH} \
	--localstatedir=/var \
	--disable-install-blobs \
	--disable-strip \
	--localstatedir=/var \
	--disable-download \
	--disable-relocatable \

# this disables building of qemu-keymap tool (!)
# qemu-keymap might be helpful for qemu-system -k <lang>
# but is -k flag useful these days?
common_configure_opts += --disable-xkbcommon

# pvrdma is an extension/optimisation for vmxnet3 vmware virtual network
# adapter. This piece of code seems to be buggy and poorly maintained,
# resulting in numerous security issues which comes unfixed for long time.
# This device isn't native for qemu.  # Just disable it for now.
common_configure_opts += --disable-pvrdma

# Cross compiling support
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
common_configure_opts  += --cross-prefix=$(DEB_HOST_GNU_TYPE)-
endif

comma:=,

# qemu-system (softmmu) targets, in multiple packages
# For each package:
#  system-archlist-$pkg - list qemu architectues which should go to this pkg
#  system-kvmcpus-$pkg  - list of ${DEB_HOST_ARCH_CPU}s where we create
#                         kvm link for this package
# For each of ${system-archlist-*}, optional:
#  system-alias-$qcpu   - aliases for this qemu architecture
# For each of ${system-kvmcpus-*}, mandatory:
#  system-kvmlink-$dcpu - where to point kvm link for this ${DEB_HOST_ARCH_CPU}

system-archlist-arm = aarch64 arm
system-alias-aarch64 = arm64
system-alias-arm = armel armhf
system-kvmcpus-arm = arm64 arm
system-kvmlink-arm64 = aarch64
system-kvmlink-arm = arm

system-archlist-mips = mips mipsel mips64 mips64el

system-archlist-ppc = ppc ppc64
system-alias-ppc = powerpc
system-alias-ppc64 = ppc64le ppc64el
system-kvmcpus-ppc = ppc64 ppc64el powerpc
system-kvmlink-ppc64 = ppc64
system-kvmlink-ppc64el = ppc64
system-kvmlink-powerpc = ppc

system-archlist-sparc = sparc sparc64

system-s390x = $(if $(filter ${VENDOR},UBUNTU),s390x)

system-archlist-s390x = ${system-s390x}
system-kvmcpus-s390x = s390x
system-kvmlink-s390x = s390x

system-archlist-x86 = i386 x86_64
system-alias-x86_64 = amd64
system-kvmcpus-x86 = amd64 i386
system-kvmlink-amd64 = x86_64
system-kvmlink-i386 = x86_64

system-archlist-misc = alpha avr cris hppa m68k loongarch64 \
		microblaze microblazeel nios2 or1k riscv32 riscv64 rx sh4 sh4eb \
		$(if ${system-s390x},,s390x) \
		tricore xtensa xtensaeb
system-alias-loongarch64 = loong64
system-kvmcpus-misc = $(if ${system-s390x},,s390x)

system-packages = arm mips ppc sparc x86 ${system-s390x} misc

# install-system qemu-system-$pkg, ${system-archlist-$pkg}, kvm-link
# install qemu-arch-list binaries with manpages and aliases into pkg
# install kvm link to qemu-system-${kvm-link} if it is not empty
# fills in qemu:Provides and qemu:archlist substvars
define install-system
	# installing $1
	dh_installdirs -p $1 usr/bin usr/share/man/man1
	mv -t debian/$1/usr/bin/ $(addprefix debian/tmp/usr/bin/qemu-system-,$2)
$(foreach q,$2,\
	@echo ".so man1/qemu-system.1" > debian/$1/usr/share/man/man1/qemu-system-$q.1
    $(foreach a,${system-alias-$q},\
	dh_link -p $1 usr/bin/qemu-system-$q usr/bin/qemu-system-$a
	dh_link -p $1 usr/share/man/man1/qemu-system-$q.1 usr/share/man/man1/qemu-system-$a.1
))
$(if $3,\
	dh_link -p $1 usr/bin/$3 usr/bin/kvm
	dh_link -p $1 usr/share/man/man1/$3.1 usr/share/man/man1/kvm.1
)
	echo 'qemu:Provides=$(if $3,qemu-kvm (=${DEB_VERSION})${comma})\
	 $(patsubst %,qemu-system-% (=${DEB_VERSION})${comma}, any $2 $(foreach q,$2,${system-alias-$q}))' \
	    | tr _ - >> debian/$1.substvars
# construct list `arch1 arch2 (alias) arch3..' for Description
# and word-wrap it into two lines if too long
	list='$(foreach q,$2,$q$(if ${system-alias-$q}, (${system-alias-$q})))'; \
	  len2=$$(($${#list}/2)); \
	  if [ $$len2 -gt 36 ]; then \
	    while expr substr "$$list" $$len2 1 != " " >/dev/null; do len2=$$(($$len2+1)); done; \
	    list="$$(expr substr "$$list" 1 $$(($$len2-1)))\$${Newline} $$(expr substr "$$list" $$(($$len2+1)) $$len2)"; \
	  fi; \
	  echo "qemu:archlist=$$list" >> debian/$1.substvars
	dh_installdocs -p $1 --link-doc=qemu-system-common
endef

sysdata-components :=
qemu-builds :=

# several builds of qemu binaries:

##############################################
# main system and tools build
configure-qemu: b/qemu/configured
b/qemu/configured: configure
	rm -rf b/qemu; mkdir -p b/qemu
	cd b/qemu && \
	    ../../configure ${common_configure_opts} \
		--$(if ${enable-system},enable,disable)-system \
		--disable-user --disable-linux-user \
		--enable-tools \
		--disable-xen \
		--enable-modules \
		$(if ${enable-system},--enable-module-upgrades) \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		${QEMU_CONFIGURE_OPTIONS} || \

## qemu 8.2.2%2Bds

=== roms/u-boot/arch/x86/cpu/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2006
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#
# (C) Copyright 2002
# Daniel Engström, Omicron Ceti AB, daniel@omicron.se.

ifeq ($(CONFIG_$(SPL_)X86_64),y)
extra-y	= start64.o
else
ifeq ($(CONFIG_$(SPL_TPL_)X86_16BIT_INIT),y)
extra-y	= start.o
else
ifndef CONFIG_SPL
extra-y	= start.o
else
ifdef CONFIG_SPL_BUILD
extra-y	= start_from_tpl.o
else
extra-y	= start_from_spl.o
endif
endif
endif
endif

extra-$(CONFIG_$(SPL_TPL_)X86_16BIT_INIT) += resetvec.o start16.o

obj-y	+= cpu.o
ifndef CONFIG_TPL_BUILD
obj-y	+= cpu_x86.o
endif

ifndef CONFIG_$(SPL_)X86_64
AFLAGS_REMOVE_call32.o := -mregparm=3 \
	$(if $(CONFIG_EFI_STUB_64BIT),-march=i386 -m32)
AFLAGS_call32.o := -fpic -fshort-wchar \
	$(if $(CONFIG_EFI_STUB_64BIT),-m64)

extra-y += call32.o
endif

obj-y += intel_common/
obj-$(CONFIG_INTEL_APOLLOLAKE) += apollolake/
obj-$(CONFIG_INTEL_BAYTRAIL) += baytrail/
obj-$(CONFIG_INTEL_BRASWELL) += braswell/
obj-$(CONFIG_INTEL_BROADWELL) += broadwell/
obj-$(CONFIG_SYS_COREBOOT) += coreboot/
obj-$(CONFIG_SYS_SLIMBOOTLOADER) += slimbootloader/
obj-$(CONFIG_EFI) += efi/
obj-$(CONFIG_QEMU) += qemu/
obj-$(CONFIG_NORTHBRIDGE_INTEL_IVYBRIDGE) += ivybridge/
obj-$(CONFIG_INTEL_QUARK) += quark/
obj-$(CONFIG_INTEL_QUEENSBAY) += queensbay/
obj-$(CONFIG_INTEL_TANGIER) += tangier/
obj-$(CONFIG_APIC) += lapic.o ioapic.o
obj-$(CONFIG_$(SPL_TPL_)ACPI_GPE) += acpi_gpe.o
obj-$(CONFIG_QFW) += qfw_cpu.o
ifndef CONFIG_SYS_COREBOOT
obj-$(CONFIG_$(SPL_TPL_)X86_32BIT_INIT) += irq.o
endif
ifndef CONFIG_$(SPL_)X86_64
obj-$(CONFIG_$(SPL_)SMP) += mp_init.o
endif
obj-y += mtrr.o
obj-$(CONFIG_PCI) += pci.o
ifndef CONFIG_$(SPL_)X86_64
obj-$(CONFIG_SMP) += sipi_vector.o
endif
obj-y += turbo.o
obj-$(CONFIG_HAVE_ACPI_RESUME) += wakeup.o

ifeq ($(CONFIG_$(SPL_)X86_64),y)
obj-y += x86_64/
else
obj-y += i386/
endif

=== roms/u-boot/board/st/common/Makefile ===
# SPDX-License-Identifier: GPL-2.0+ OR BSD-3-Clause
#
# Copyright (C) 2020, STMicroelectronics - All Rights Reserved
#

obj-$(CONFIG_CMD_STBOARD) += cmd_stboard.o
obj-$(CONFIG_PMIC_STPMIC1) += stpmic1.o

ifeq ($(CONFIG_ARCH_STM32MP),y)
obj-$(CONFIG_SYS_MTDPARTS_RUNTIME) += stm32mp_mtdparts.o
obj-$(CONFIG_SET_DFU_ALT_INFO) += stm32mp_dfu.o
endif

obj-$(CONFIG_TYPEC_STUSB160X) += stusb160x.o

=== roms/u-boot/arch/arm/cpu/armv7/iproc-common/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# Copyright 2014 Broadcom Corporation.

obj-y	+= armpll.o
obj-y	+= hwinit-common.o
obj-y	+= timer.o

=== debian/changelog ===
qemu (1:8.2.2+ds-0ubuntu1) noble; urgency=medium

  * Merge version 8.2.2 from upstream. (LP: #2061005).  Cherry-picks from
    Debian:
    - d/p/ui-clipboard-mark-type-as-not-available-when-no-data-CVE-2023-6683.patch:
      Remove patch; included upstream.
    - d/control: clarify qemu-system-gui description: this is not a
      management gui for qemu
    - d/rules: stop qemu-system-${arch} packages from providing
      themselves (#1063233)
    - d/control{,-in}: Fix typo on qemu-system-gui description.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 12 Apr 2024 18:13:51 -0400

qemu (1:8.2.1+ds-1ubuntu9) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:20:15 +1100

qemu (1:8.2.1+ds-1ubuntu8) noble; urgency=medium

  * d/p/u/lp2012763-maxcpus-too-low.patch: Actually set the max_cpus
    property of the new Mantic machine types. (LP: #2012763)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 25 Mar 2024 14:58:39 -0400

qemu (1:8.2.1+ds-1ubuntu7) noble; urgency=medium

  * d/p/u/lp2012763-maxcpus-too-low.patch: Bump max_cpus to 1024 on
    Jammy amd64 machine types.  (LP: #2012763)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 18 Mar 2024 16:48:22 -0400

qemu (1:8.2.1+ds-1ubuntu6) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:16:54 +0000

qemu (1:8.2.1+ds-1ubuntu5) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:31:21 +0000

qemu (1:8.2.1+ds-1ubuntu4) noble; urgency=medium

  * No-change rebuild against libgnutls30t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Mar 2024 02:11:43 +0000

qemu (1:8.2.1+ds-1ubuntu3) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:54:00 +0000

qemu (1:8.2.1+ds-1ubuntu2) noble; urgency=medium

  * d/p/u/lp-2055003-*: Properly initialize max_cpus limit to
    SPAPR_IRQ_NR_IPIS, fixing a segfault on ppc64el. (LP: #2055003)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 26 Feb 2024 15:32:25 -0500

qemu (1:8.2.1+ds-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2051883, #2049703). Remaining changes:
    - qemu-kvm to systemd unit
      - d/qemu-kvm-init: script for QEMU KVM preparation modules, ksm,
        hugepages and architecture specifics
      - d/qemu-system-common.qemu-kvm.service: systemd unit to call
        qemu-kvm-init
      - d/qemu-system-common.install: install helper script
      - d/qemu-system-common.qemu-kvm.default: defaults for
        /etc/default/qemu-kvm
      - d/rules: call dh_installinit and dh_installsystemd for qemu-kvm
    - Distribution specific machine type
      (LP 1304107 1621042 1776189 1761372 1761372 1776189)
      - d/p/ubuntu/define-ubuntu-machine-types.patch: define distro machine
        types containing release versioned machine attributes
      - Add an info about -hpb machine type in debian/qemu-system-x86.NEWS
      - ubuntu-q35 alias added to auto-select the most recent q35 ubuntu type
    - Enable nesting by default
      - d/p/ubuntu/enable-svm-by-default.patch: Enable nested svm by default
        in qemu64 on amd
        [ No more strictly needed, but required for backward compatibility ]
    - tolerate ipxe size change on migrations to >=18.04 (LP 1713490)
      - d/p/ubuntu/pre-bionic-256k-ipxe-efi-roms.patch: old machine types
        reference 256k path
      - d/control-in: depend on ipxe-qemu-256k-compat-efi-roms to be able to
        handle incoming migrations from former releases.
    - Ease the use of module retention on upgrades (LP 1913421)
      - debian/qemu-block-extra.postinst: enable mount unit on install/upgrade
    - Remaining GCC-12 FTBFS (LP 1988710 + LP 1921664)
      + d/p/u/qboot-Disable-LTO-for-ELF-binary-build-step.patch:
        fix qboot FTBFS with LTO
    - d/rules: Enable/disable extra features on microvm
      variant. (LP #2045594)
    - Move glusterfs storage driver to Universe in a new package
      (LP #2045063):
      + d/control{,-in}: new package qemu-block-supplemental for drivers
        we want in Universe
      + d/rules: we only want block-gluster.so in the new
        qemu-block-supplemental package. Adjust dynamically-created
        maintainer scripts for qemu-block-extra and -supplemental.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 07 Feb 2024 13:01:14 -0500

qemu (1:8.2.0+ds-4ubuntu2) noble; urgency=medium

  * Move glusterfs storage driver to Universe in a new package
    (LP: #2045063):
    - d/control{,-in}: new package qemu-block-supplemental for drivers
      we want in Universe
    - d/rules: we only want block-gluster.so in the new
      qemu-block-supplemental package. Adjust dynamically-created
      maintainer scripts for qemu-block-extra and -supplemental.

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 02 Feb 2024 14:07:00 -0300
